#ifndef PARSE_H
#define PARSE_H

typedef enum {
   E_NOTHING,
/* these six are hard-coded in the timer2 pushbutton code, */
/* so changing them also requires changing isr.asi */
   E_NEXT,
   E_PLAY_PAUSE,
   E_PREV,
   E_RANDOM,
   E_VOL_UP,
   E_VOL_DOWN,
   spare7,
   spare8,
   spare9,
/* these are also hard-coded inside the interrupt routine */
   E_LCD_SCROLL_TIMER,
   E_LCD_TIMEOUT_TIMER,
   E_PARAM_WRITE_TIMER,
   E_ID3_UPDATE_TIMER,
   E_TIMER4,
   E_TIMER5,
   E_TIMER6,
   E_TIMER7,
   spare18,
   spare19,
/* these are easy to change if needed */
   E_INC,
   E_DEC,
   E_NEXT_LIST,
   E_PREV_LIST,
   E_UP,
   E_DOWN,
   E_LEFT,
   E_RIGHT,
   E_ENTER,
   E_FWD,
   E_REV,
   E_DISPLAY1
} event_t;


extern void parse_init(void);
extern void parse_serial_input(void);
extern void parse_event_setup(void);

#endif /* PARSE_H */
