#include "params.h"

struct playback_struct {
        char mode_known;
        char /* code (sdcc bug) */  *mode;
        int bitrate;
        unsigned char freq;
	unsigned char ms_per_frame;
};

extern void restore_sta013_settings(void);
extern void backup_sta013_settings(void);

extern void action_vol_up(void);
extern void action_vol_down(void);
extern void init_silent_mp3_clip(void);
extern void play_silent_mp3_clip(void);
void mute_sta013_output(void);
void set_sta013_treble_frequency(void);
void set_sta013_bass_frequency(void);
void sta013_tone_up(param_t tone_param);
void sta013_tone_down(param_t tone_param);

extern struct playback_struct playback;

#define STA013_HEAD_H 0x43      /* bits 16-23 */
#define STA013_HEAD_M 0x44      /* bits 8-15 */
#define STA013_HEAD_L 0x45      /* bits 0-7 */
#define STA013_SYNC_STATUS 0x40  
#define STA013_AVG_BITRATE 0x6A  /* does this really work? */
#define STA013_FRAME_CNT_L 0x67 // Number of frames since MP3 decoder last reset.
#define STA013_FRAME_CNT_M 0x68 // We'll use these for the time display
#define STA013_FRAME_CNT_H 0x69 


#define NUM_BASS_FREQ 13
#define NUM_TREBLE_FREQ 13
#define STA013_PARAM_CENTRE 127
#define STA013_MAX_TONE 12

extern code unsigned int bass_freq_table[];
extern code unsigned int treble_freq_table[];

extern unsigned char update_playback_parms(void);
extern unsigned long GetFrameCount();
